#include <16F88.h>
#fuses NOWDT,NOPROTECT,NOLVP,NOFCMEN,NOBROWNOUT,HS
#use delay(clock=20000000)

#define NODE_ADDR   0x30

#include <..\Libs\I2CSlave.c>

#define DEFAULT_CHANNEL_CHANGE_DELAY	25

#define hi(x)  (*(&x+1))

BYTE FeetValues[6];

void main() {
	//setup_oscillator(OSC_8MHZ);
	setup_ccp1(CCP_OFF);

	output_a(0);
	output_b(0);
	
	setup_adc(ADC_CLOCK_INTERNAL);
	setup_adc_ports(sAN0 | sAN1 | sAN2 | sAN4 | sAN5 | sAN6);

	i2c_initialize();

	enable_interrupts(GLOBAL);

	//set all our inputs to float
	output_float(PIN_A0);
	output_float(PIN_A1);
	output_float(PIN_A2);

	//output_float(PIN_A3);

	output_float(PIN_A4);
	output_float(PIN_B6);  //AN5 = PIN_B6 because of the oscillator pins on port a
	output_float(PIN_B7);  //AN6 = PIN_B7 because of the oscillator pins on port a

	while(1)
	{
		BYTE channel;
		
		set_adc_channel(0);
		delay_us(DEFAULT_CHANNEL_CHANGE_DELAY);
		FeetValues[0] = read_adc();
		
		set_adc_channel(1);
		delay_us(DEFAULT_CHANNEL_CHANGE_DELAY);
		FeetValues[1] = read_adc();
		
		set_adc_channel(2);
		delay_us(DEFAULT_CHANNEL_CHANGE_DELAY);
		FeetValues[2] = read_adc();
		
		//skipping channel 3, its VREF+
		set_adc_channel(4);
		delay_us(DEFAULT_CHANNEL_CHANGE_DELAY);
		FeetValues[3] = read_adc();
		
		set_adc_channel(5);
		delay_us(DEFAULT_CHANNEL_CHANGE_DELAY);
		FeetValues[4] = read_adc();
		
		set_adc_channel(6);
		delay_us(DEFAULT_CHANNEL_CHANGE_DELAY);
		FeetValues[5] = read_adc();
	}
}

void i2c_start_read()
{
	slave_buffer[0] = FeetValues[0];
	slave_buffer[1] = FeetValues[1];
	slave_buffer[2] = FeetValues[2];
	slave_buffer[3] = FeetValues[3];
	slave_buffer[4] = FeetValues[4];
	slave_buffer[5] = FeetValues[5];
}

void i2c_end_request()
{
	/*BYTE cmd;
	
	cmd = slave_buffer[1];
	
	switch (cmd)
	{

	}
	*/
}
